# Tests for PriorityQueue objects
pq := PriorityQueue( x -> x, 2,1,4,3,6,5 );
pq:-top();
pq:-size();
pq:-empty();
while not pq:-empty() do pq:-delete() od;
pq:-size();
pq:-empty();

N := 1000:
r := rand( 1 .. N ):
pq := PriorityQueue( x -> x );
st:=time():
for i from 1 to N do
	pq:-insert( r( i ) )
end do:
time()-st;
pq:-size();
pq:-top();
pq:-empty();

st:=time():
while not pq:-empty() do
	pq:-size():
	pq:-top():
	pq:-delete():
end do:
time()-st;
pq:-size();
pq:-empty();

HeapSort := proc(L::list(numeric))
	local	pq, i;
	global	PriorityQueue;
	pq := PriorityQueue( x -> -x, op( L ) );
	[ seq( pq:-delete(), i = 1 .. pq:-size() ) ]
end proc:

L := [ seq( r(i), i = 1 .. 40 ) ];
HeapSort( L );
evalb( % = sort( %, 'numeric' ) );

pq := PriorityQueue( x -> length( x ) ):
rp := () -> randpoly( [ 'x', 'y', 'z' ], 'expons' = rand( -10 .. 10 ) ):

pq:-empty();
pq:-size();
st := time():
for i from 1 to N do
	pq:-insert( rp() )
end do:
time() - st;
pq:-empty();
pq:-size();
pq:-top();
st := time():
for i from 1 to N do
	pq:-insert( rp() )
end do:
time() - st;
pq:-empty();
pq:-size();
pq:-top();
st := time():
while not pq:-empty() do
	pq:-size();
	pq:-top();
	pq:-delete()
end do:
time() - st;
pq:-empty();
pq:-size();

timeInsertPQ := proc( pq, n )
	local	i, st;
	st := time();
	for i from 1 to n do
		pq:-insert( i )
	end do;
	time() - st
end proc:
timeDeletePQ := proc( pq )
	local	st;
	st := time();
	while not pq:-empty() do
		pq:-delete()
	end do;
	time() - st;
end proc:

pq := PriorityQueue( x -> x );
timeInsertPQ( pq, 100 );
timeDeletePQ( pq );

