# differentiate.tst -- test file for the differentiator sample code
bind( DiffImpl ):
$ifdef	COVERAGE
debugopts( traceproc = differentiate );
$endif	# COVERAGE
differentiate( 2, x );
differentiate( Pi, x );
differentiate( x, x );

p := randpoly( x );
differentiate( p, x );
differentiate( a*x^2 - b*x + c, x );

differentiate( f( x ), x );
differentiate( f( x ) + g( x ), x );
differentiate( f( x ) - g( x ), x );
differentiate( f( x ) * g( x ), x );
differentiate( f( x ) * g( x ) * h( x ), x );
differentiate( f( x ) / g( x ), x );

differentiate( ('f@g')(x), x );
differentiate( f(g(x)), x );
differentiate( (f^g)(x), x );

differentiate( exp( x ), x );
differentiate( ln( x ), x );

differentiate( sin( x ), x );
differentiate( cos( x ), x );
differentiate( tan( x ), x );
differentiate( csc( x ), x );
differentiate( sec( x ), x );
differentiate( cot( x ), x );

differentiate( sinh( x ), x );
differentiate( cosh( x ), x );
differentiate( tanh( x ), x );
differentiate( csch( x ), x );
differentiate( sech( x ), x );
differentiate( coth( x ), x );

differentiate( arcsin( x ), x );
differentiate( arccos( x ), x );
differentiate( arctan( x ), x );
differentiate( arccsc( x ), x );
differentiate( arcsec( x ), x );
differentiate( arccot( x ), x );

differentiate( arcsinh( x ), x );
differentiate( arccosh( x ), x );
differentiate( arctanh( x ), x );
differentiate( arccsch( x ), x );
differentiate( arcsech( x ), x );
differentiate( arccoth( x ), x );


differentiate( ( f . g )( x ), x );
differentiate( f( x ) . g( x ), x );
differentiate( f[x]( a ), x );

m := module() export sin, cos; end:
DiffImpl:-addFunc( m:-sin, m:-cos ):
DiffImpl:-addFunc( m:-cos, x -> - m:-sin( x ) ):
differentiate( m:-sin( x ) + cos( x ), x );
differentiate( m:-cos( x ) - m:-sin( x ), x );

$ifdef	COVERAGE
showstat( differentiate );
$endif	# COVERAGE
