########################################################################
########################################################################
###
###	Filename: Graph2.mpl
###
###     Copyright (c) 1999 Waterloo Maple, Inc.
###
###     THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF WMI
###     The copyright notice above does not evidence any
###     actual or intended publication of such source code.
###
########################################################################
########################################################################
###
###	NAME
###
###	SYNPOPSIS
###
###	PARAMETERS
###
###	DESCRIPTION
###
########################################################################
########################################################################

`type/Graph` := '`module`( order, size, edges, vertices, addedge )':
#savelib( '`type/Graph`' ):
$ifdef	LOAD_REPOSITORY
savelib( '`type/Graph`' ):
$endif	# LOAD_REPOSITORY


Graph2 := proc()
	local	vertex_set, edge_set;

	edge_set := { args };
	vertex_set := map( op, edge_set );
	if map( type, edge_set, 'list' ) <> { true } then
		error "graph must be specified by a sequence of edges"
	end if;
	if map( nops, edge_set ) <> { 2 } then
		error "each edge must be specified as a [ source, target ] pair"
	end if;

	module()
		export	order,
			size,
			vertices,
			addedge,
			edges;
		local	N, e, v, n, edge_pairs;

		for e in edge_set do
			if assigned( N[ op( 1, e ) ] ) and not member( op( 2, e ), N[ op( 1, e ) ] ) then
				N[ op( 1, e ) ] := { op( N[ op( 1, e ) ] ), op( 2, e ) }
			else
				N[ op( 1, e ) ] := { op( 2, e ) }
			end if
		end do;

		edge_pairs := () -> {
			seq(
				seq( [ v, n ], n = N[ v ] ),
				v = map( op, { indices( N ) } )
			)
		};
		vertices := () -> map( op, edge_pairs() );
		edges := () -> map( Edge@op, edge_pairs() );
		addedge := proc( src, targ )
			if assigned( N[ src ] ) and not member( targ, N[ src ] ) then
				N[ src ] := { op( N[ src ] ), targ }
			else
				N[ src ] := { targ };
			end if;
			NULL
		end proc;
		order := nops( vertices() );
		size := nops( edges() );
		print(eval(N));
	end module
end proc:
#savelib( 'Graph2' ):
$ifdef	LOAD_REPOSITORY
savelib( 'Graph2' ):
$endif	# LOAD_REPOSITORY

########################################################################
########################################################################
###
###	End of File: Graph2.mpl
###
########################################################################
########################################################################
